package de.jatitv.commandguiv2.Spigot.config.gui;

import de.jatitv.commandguiv2.Spigot.Main;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import org.bukkit.configuration.file.YamlConfiguration;

import java.io.File;
import java.io.IOException;
import java.util.Arrays;
import java.util.List;


public class CreateGUI {
    public static void configCreate() {
        long long_ = System.currentTimeMillis();
        send.console(Main.prefix + " §4Default GUI file (GUIs/default.yml) is loaded...");
        File config = new File(Main.getPath(), "GUIs/default.yml");
        YamlConfiguration yamlConfiguration = YamlConfiguration.loadConfiguration(config);

        set("GUI.Enable", true, yamlConfiguration);
        set("GUI.Lines", 1, yamlConfiguration);
        set("GUI.Name", "&5default &9GUI", yamlConfiguration);
        set("GUI.FillItem.Enable", true, yamlConfiguration);
        if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
            set("GUI.FillItem.GlassPaneColor", 15, yamlConfiguration);
        } else set("GUI.FillItem.Item", "BLACK_STAINED_GLASS_PANE", yamlConfiguration);

        set("Command.Alias", true, yamlConfiguration);
        set("Command.Permission.Required", true, yamlConfiguration);

        set("Slots.SupportDiscord.Slot", 4, yamlConfiguration);
        set("Slots.SupportDiscord.Enable", true, yamlConfiguration);
        set("Slots.SupportDiscord.Function", "SupportDiscord", yamlConfiguration);
        set("Slots.SupportDiscord.Permission.Required", false, yamlConfiguration);
        set("Slots.SupportDiscord.Permission.See", "commandgui.gui.[guiname].slot.[slot].see", yamlConfiguration);
        set("Slots.SupportDiscord.Permission.Use", "commandgui.gui.[guiname].slot.[slot].use", yamlConfiguration);

        set("Slots.UseItem.Slot", 6, yamlConfiguration);
        set("Slots.UseItem.Enable", true, yamlConfiguration);
        set("Slots.UseItem.Function", "UseItem", yamlConfiguration);
        set("Slots.UseItem.Permission.Required", false, yamlConfiguration);
        set("Slots.UseItem.Permission.See", "commandgui.gui.[guiname].slot.[slot].see", yamlConfiguration);
        set("Slots.UseItem.Permission.Use", "commandgui.gui.[guiname].slot.[slot].use", yamlConfiguration);


        try {
            yamlConfiguration.save(config);
        } catch (IOException e) {
            e.printStackTrace();
        }
        send.console(Main.prefix + " §2Default GUI file (GUIs/default.yml) was loaded." + " §7- §e" + (System.currentTimeMillis() - long_) + "ms");
    }

    private static void set(String path, String value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Integer value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }

    private static void set(String path, Boolean value, YamlConfiguration config) {
        if (!config.contains(path)) {
            config.set(path, value);
        }
    }
}
