package de.jatitv.commandguiv2.Spigot.gui;

import de.jatitv.commandguiv2.Spigot.Listener.GUI_Listener;
import de.jatitv.commandguiv2.Spigot.Listener.UseItem_Listener.Events;
import de.jatitv.commandguiv2.Spigot.Main;
import de.jatitv.commandguiv2.Spigot.objects.functions.Function;
import de.jatitv.commandguiv2.Spigot.config.languages.SelectMessages;
import de.jatitv.commandguiv2.Spigot.objects.guis.Gui;
import de.jatitv.commandguiv2.Spigot.config.config.SelectConfig;
import de.jatitv.commandguiv2.Spigot.objects.slots.Slot;
import de.jatitv.commandguiv2.Util;
import io.github.solyze.plugmangui.inventories.PluginListGUI;
import net.t2code.lib.Spigot.Lib.messages.send;
import net.t2code.lib.Spigot.Lib.minecraftVersion.MCVersion;
import net.t2code.lib.Spigot.Lib.replace.Replace;
import net.t2code.luckyBox.api.LuckyBoxAPI;
import org.bukkit.Bukkit;
import org.bukkit.Material;
import org.bukkit.entity.Player;
import org.bukkit.inventory.Inventory;
import org.bukkit.inventory.InventoryHolder;
import org.bukkit.inventory.ItemStack;
import org.bukkit.plugin.Plugin;

public class OpenGUI {
    private static Plugin plugin = Main.plugin;
    private static String prefix = Util.getPrefix();

    public static void openGUI(Player player, String guiString) {
        Gui gui = Main.guiHashMap.get(guiString);
        Long long_ = Long.valueOf(System.currentTimeMillis());
        switch (guiString) {
            //case "plugin.PlotSquaredGUI":
            //    if (Main.PlotSquaredGUI) {
            //        PlotSquaredGUIapi.openMainGUI(player);
            //    } else {
            //        if (player.hasPermission("commandgui.admin")) {
            //            send.player(player, prefix + " §4PlotSquaredGUI could not be found! §9Please download it here: " +
            //                    "§6https://spigotmc.org/resources/plotsquaredgui.77506/");
            //        }
            //    }
            //    return; todo
            case "plugin.PlugManGUI":
                if (Main.PlugManGUI) {
                    player.openInventory((new PluginListGUI(54, 1)).getInventory());
                } else {
                    if (player.hasPermission("commandgui.admin")) {
                        send.player(player, prefix + " §4PlugManGUI could not be found! §9Please download it here: " +
                                "§6https://spigotmc.org/resources/plugmangui.87599/");
                    }
                }
                return;
            case "plugin.T2C-LuckyBox":
                if (Main.LuckyBox) {
                    LuckyBoxAPI.openShop(player);
                } else {
                    if (player.hasPermission("commandgui.admin")) {
                        send.player(player, prefix + " §4T2C-LuckyBox could not be found! §9Please download it here: " +
                                "§6https://www.spigotmc.org/resources/luckybox.98154/");
                    }
                }
                return;
        }

        if (MCVersion.minecraft1_13) {
            GUI_Listener.GUICode = "";
        } else GUI_Listener.GUICode = "§6§8§9§r";
        if (gui.GUI_Enable || player.hasPermission("commandgui.bypass")) {
            Inventory inventory;
            if (Main.PaPi) {
                inventory = Bukkit.createInventory((InventoryHolder) null, 9 * gui.GUI_Lines, (Replace.replace(prefix, player, GUI_Listener.GUICode + gui.GUI_Name)));
            } else inventory = Bukkit.createInventory((InventoryHolder) null, 9 * gui.GUI_Lines, (Replace.replace(prefix, GUI_Listener.GUICode + gui.GUI_Name)));

            if (gui.GUI_FillItem_Enable) {
                GuiBuilder.fillItem(inventory, gui);
            }
            for (Slot slot : gui.slots) {
                Function function = Main.functionHashMap.get(slot.function);
                if (slot.permission || !player.hasPermission(slot.permissionToSee)) continue;
                if (slot.enable) {
                    if (function.empty) {
                        ItemStack air = new ItemStack(Material.AIR);
                        inventory.setItem(slot.slot, air);
                    } else {
                        if (function.togglePermission) {
                            if (player.hasPermission(function.togglePermissionPerm)) {
                                toggleOn(function, slot.slot, player, inventory);
                            } else {
                                toggleOff(function, slot.slot, player, inventory);
                            }
                        } else if (function.toggleUseItem) {
                            if (Events.useItemHashMap.get(player)) {
                                toggleOn(function, slot.slot, player, inventory);
                            } else {
                                toggleOff(function, slot.slot, player, inventory);
                            }
                        } else {
                            if (function.playerHead_Enable) {
                                if (MCVersion.minecraft1_8 || MCVersion.minecraft1_9 || MCVersion.minecraft1_10 || MCVersion.minecraft1_11 || MCVersion.minecraft1_12) {
                                    send.player(player, prefix + "§c Playerheads are only available from version §61.13§c! §7- §bGUI: §6" +
                                            Replace.replace(prefix, gui.GUI_Name).toString() + " §bSlot: §6" + (slot.slot + 1) + " §7- " + Replace.replace(prefix, function.name));
                                    send.error(plugin, "Playerheads are only available from version 1.13!");
                                    send.console(prefix + " §bGUI: §6" + Replace.replace(prefix, gui.GUI_Name).toString() + " §bSlot: §6" +
                                            (slot.slot + 1) + " §7- " + Replace.replace(prefix, function.name));
                                } else {
                                    if (function.base64_Enable) {
                                        GuiBuilder.base64(function, slot.slot, player, inventory);
                                    } else {
                                        if (function.playerWhoHasOpenedTheGUI) {
                                            GuiBuilder.playerHead(function, slot.slot, player, inventory, player.getName());
                                        } else {
                                            GuiBuilder.playerHead(function, slot.slot, player, inventory, function.playerName);
                                        }
                                    }
                                }
                            } else {
                                GuiBuilder.item(function, slot.slot, player, inventory);
                            }
                        }
                    }

                }
            }
            player.openInventory(inventory);
            send.debug(plugin, "§6" + player.getName() + " §5Open §6" + Replace.replace(prefix, gui.GUI_Name) + " §5" + " §7- §e" + (System.currentTimeMillis() - long_.longValue()) + "ms");
        } else player.sendMessage(SelectMessages.GUIIsDisabled.replace("[gui]", Replace.replace(prefix, gui.GUI_Name)));
    }

    private static void toggleOn(Function function, Integer slot, Player player, Inventory inventory) {
        if (SelectConfig.toggleItemOnOrYesBase64) {
            GuiBuilder.base64(SelectConfig.toggleItemOnOrYesBase64Value, function, slot, player, inventory);
        } else GuiBuilder.item(SelectConfig.toggleItemOnOrYesMaterial, function, slot, player, inventory);
    }

    private static void toggleOff(Function function, Integer slot, Player player, Inventory inventory) {
        if (SelectConfig.toggleItemOffOrNoBase64) {
            GuiBuilder.base64(SelectConfig.toggleItemOffOrNoBase64Value, function, slot, player, inventory);
        } else GuiBuilder.item(SelectConfig.toggleItemOffOrNoMaterial, function, slot, player, inventory);
    }
}
